<?php

namespace Drupal\drupalforge_token\Hook;

use Drupal\Core\Hook\Attribute\Hook;
use Drupal\Core\Render\BubbleableMetadata;

/**
 * Token hook implementations.
 */
class TokenHooks {

  /**
   * Implements hook_tokens().
   */
  #[Hook('tokens')]
  public function tokens(string $type, array $tokens, array $data, array $options, BubbleableMetadata $bubbleable_metadata): array {
    $replacements = [];
    if ($type == 'drupalforge') {
      foreach ($tokens as $template => $token) {
        if (is_numeric($template)) {
          $build = [
            '#type' => 'html_tag',
            '#tag' => 'webform-component',
            '#attributes' => [
              'host' => 'https://www.drupalforge.org',
              'templateid' => $template,
            ],
            '#attached' => [
              'library' => [
                'drupalforge_token/webform-component',
              ],
            ],
          ];
          $replacements[$token] = \Drupal::service('renderer')->render($build);
        }
      }
    }
    return $replacements;
  }

}
